/*
Copyright 2024 The Kanister Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1alpha1

// ArtifactApplyConfiguration represents an declarative configuration of the Artifact type for use
// with apply.
type ArtifactApplyConfiguration struct {
	KeyValue      map[string]string `json:"keyValue,omitempty"`
	KopiaSnapshot *string           `json:"kopiaSnapshot,omitempty"`
}

// ArtifactApplyConfiguration constructs an declarative configuration of the Artifact type for use with
// apply.
func Artifact() *ArtifactApplyConfiguration {
	return &ArtifactApplyConfiguration{}
}

// WithKeyValue puts the entries into the KeyValue field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the KeyValue field,
// overwriting an existing map entries in KeyValue field with the same key.
func (b *ArtifactApplyConfiguration) WithKeyValue(entries map[string]string) *ArtifactApplyConfiguration {
	if b.KeyValue == nil && len(entries) > 0 {
		b.KeyValue = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.KeyValue[k] = v
	}
	return b
}

// WithKopiaSnapshot sets the KopiaSnapshot field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the KopiaSnapshot field is set to the value of the last call.
func (b *ArtifactApplyConfiguration) WithKopiaSnapshot(value string) *ArtifactApplyConfiguration {
	b.KopiaSnapshot = &value
	return b
}
