/*
Copyright 2024 The Kanister Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1alpha1

// BlueprintPhaseApplyConfiguration represents an declarative configuration of the BlueprintPhase type for use
// with apply.
type BlueprintPhaseApplyConfiguration struct {
	Func       *string                                      `json:"func,omitempty"`
	Name       *string                                      `json:"name,omitempty"`
	ObjectRefs map[string]ObjectReferenceApplyConfiguration `json:"objects,omitempty"`
	Args       map[string]interface{}                       `json:"args,omitempty"`
}

// BlueprintPhaseApplyConfiguration constructs an declarative configuration of the BlueprintPhase type for use with
// apply.
func BlueprintPhase() *BlueprintPhaseApplyConfiguration {
	return &BlueprintPhaseApplyConfiguration{}
}

// WithFunc sets the Func field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Func field is set to the value of the last call.
func (b *BlueprintPhaseApplyConfiguration) WithFunc(value string) *BlueprintPhaseApplyConfiguration {
	b.Func = &value
	return b
}

// WithName sets the Name field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Name field is set to the value of the last call.
func (b *BlueprintPhaseApplyConfiguration) WithName(value string) *BlueprintPhaseApplyConfiguration {
	b.Name = &value
	return b
}

// WithObjectRefs puts the entries into the ObjectRefs field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the ObjectRefs field,
// overwriting an existing map entries in ObjectRefs field with the same key.
func (b *BlueprintPhaseApplyConfiguration) WithObjectRefs(entries map[string]ObjectReferenceApplyConfiguration) *BlueprintPhaseApplyConfiguration {
	if b.ObjectRefs == nil && len(entries) > 0 {
		b.ObjectRefs = make(map[string]ObjectReferenceApplyConfiguration, len(entries))
	}
	for k, v := range entries {
		b.ObjectRefs[k] = v
	}
	return b
}

// WithArgs puts the entries into the Args field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Args field,
// overwriting an existing map entries in Args field with the same key.
func (b *BlueprintPhaseApplyConfiguration) WithArgs(entries map[string]interface{}) *BlueprintPhaseApplyConfiguration {
	if b.Args == nil && len(entries) > 0 {
		b.Args = make(map[string]interface{}, len(entries))
	}
	for k, v := range entries {
		b.Args[k] = v
	}
	return b
}
