/*
Copyright 2024 The Kanister Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/kanisterio/kanister/pkg/apis/cr/v1alpha1"
)

// CredentialApplyConfiguration represents an declarative configuration of the Credential type for use
// with apply.
type CredentialApplyConfiguration struct {
	Type              *v1alpha1.CredentialType             `json:"type,omitempty"`
	KeyPair           *KeyPairApplyConfiguration           `json:"keyPair,omitempty"`
	Secret            *ObjectReferenceApplyConfiguration   `json:"secret,omitempty"`
	KopiaServerSecret *KopiaServerSecretApplyConfiguration `json:"kopiaServerSecret,omitempty"`
}

// CredentialApplyConfiguration constructs an declarative configuration of the Credential type for use with
// apply.
func Credential() *CredentialApplyConfiguration {
	return &CredentialApplyConfiguration{}
}

// WithType sets the Type field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Type field is set to the value of the last call.
func (b *CredentialApplyConfiguration) WithType(value v1alpha1.CredentialType) *CredentialApplyConfiguration {
	b.Type = &value
	return b
}

// WithKeyPair sets the KeyPair field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the KeyPair field is set to the value of the last call.
func (b *CredentialApplyConfiguration) WithKeyPair(value *KeyPairApplyConfiguration) *CredentialApplyConfiguration {
	b.KeyPair = value
	return b
}

// WithSecret sets the Secret field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Secret field is set to the value of the last call.
func (b *CredentialApplyConfiguration) WithSecret(value *ObjectReferenceApplyConfiguration) *CredentialApplyConfiguration {
	b.Secret = value
	return b
}

// WithKopiaServerSecret sets the KopiaServerSecret field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the KopiaServerSecret field is set to the value of the last call.
func (b *CredentialApplyConfiguration) WithKopiaServerSecret(value *KopiaServerSecretApplyConfiguration) *CredentialApplyConfiguration {
	b.KopiaServerSecret = value
	return b
}
