/*
Copyright 2024 The Kanister Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1alpha1

import (
	v1 "k8s.io/api/core/v1"
)

// ServerApplyConfiguration represents an declarative configuration of the Server type for use
// with apply.
type ServerApplyConfiguration struct {
	UserAccess     *UserAccessApplyConfiguration `json:"userAccess,omitempty"`
	AdminSecretRef *v1.SecretReference           `json:"adminSecretRef,omitempty"`
	TLSSecretRef   *v1.SecretReference           `json:"tlsSecretRef,omitempty"`
}

// ServerApplyConfiguration constructs an declarative configuration of the Server type for use with
// apply.
func Server() *ServerApplyConfiguration {
	return &ServerApplyConfiguration{}
}

// WithUserAccess sets the UserAccess field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UserAccess field is set to the value of the last call.
func (b *ServerApplyConfiguration) WithUserAccess(value *UserAccessApplyConfiguration) *ServerApplyConfiguration {
	b.UserAccess = value
	return b
}

// WithAdminSecretRef sets the AdminSecretRef field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the AdminSecretRef field is set to the value of the last call.
func (b *ServerApplyConfiguration) WithAdminSecretRef(value v1.SecretReference) *ServerApplyConfiguration {
	b.AdminSecretRef = &value
	return b
}

// WithTLSSecretRef sets the TLSSecretRef field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the TLSSecretRef field is set to the value of the last call.
func (b *ServerApplyConfiguration) WithTLSSecretRef(value v1.SecretReference) *ServerApplyConfiguration {
	b.TLSSecretRef = &value
	return b
}
